; :
;   ࠬ   cs:tbl_Adr
;    ⠪  㦥 cs:Drive  ah=$42 - ⥭, $43 - 

; :
;   lds	si,cs:ReqAdr
;    訡: or	[si].rh_status,800ch
;
cmd	db ?
;
DirRWTS:
 push cs
 pop ds
 cld
 mov cmd,ah
 call CalcOfsPort
 mov cl,040h
 call GetStatus
 cmp cmd,43h
 je Write_L
;
;  ⥭
;
 mov bl,020h
 call RegPrepare

Read_3:
 mov cl,008h
 call GetStatus

 mov dx,port1
 les di,tbl_AdrAdress
 cmp Direct32,0
 jne Read_1

 mov cx,BT2SC/2 ; Read (16 Bit)
 rep insw
 jmp Read_2

Read_1:
 mov cx,BT2SC/4 ; Read (32 Bit)
 rep insd

Read_2:
 mov word ptr tbl_AdrAdress+0,di
 mov word ptr tbl_AdrAdress+2,es
 dec tbl_AdrCount
 jnz Read_3

Read_L:
 xor al,al
 mov dx,port2
 out dx,al ; ࠧ蠥 뢠 ( 直 砩)

 lds si,ReqAdr
 retn
;
;  
;
Write_L:
 mov bl,030h
 call RegPrepare

Write_3:
 mov cl,008h
 call GetStatus

 mov dx,port1
 push ds
 lds si,tbl_AdrAdress
 cmp cs:Direct32,0
 jne Write_1

 mov cx,BT2SC/2 ; Write (16 Bit)
 rep outsw
 jmp Write_2

Write_1:
 mov cx,BT2SC/4 ; Write (32 Bit)
 rep outsd

Write_2:
 mov cs:word ptr tbl_AdrAdress+0,si
 mov cs:word ptr tbl_AdrAdress+2,ds
 pop ds
 dec tbl_AdrCount
 jnz Write_3
 jmp Read_L
;
; 뢠   Drive  ⮢    Slave-ࠩ
;
CalcOfsPort:
 mov al,Drive
 cmp al,128
 jb COP_err
 cmp al,128+7
 ja COP_err
 xor ah,ah
 shr al,1
 rcl ah,5
 shl al,1
 or ah,0E0h
 mov sdev,ah
 mov bx,ax
 and bx,0007h
 mov ax,ofsP1[bx]
 mov port1,ax
 mov ax,ofsP2[bx]
 mov port2,ax
 retn

COP_err:
 lds si,ReqAdr
 or [si].rh_status,800ch
 pop ax
 retn
;
ofsP1 dw 1f0h,170h,1e8h,168h
ofsP2 dw 3f6h,376h,3eeh,36eh
port1 dw ?
port2 dw ?
sdev  db ?
;
;  ⮢ ன⢠
; cl=$40    $08  
;
TimerOffs=046Ch ; ebx - Time
;
GetStatus:
 xor ax,ax
 mov es,ax
 mov ebx,es:TimerOffs
 add ebx,9
 mov dx,port1
 add dx,7
GS_1:
 call GS_timer
 in al,dx
 test al,80h
 jnz GS_1
GS_2:
 call GS_timer
 in al,dx
 test al,cl
 jz GS_2
 cmp cl,40h
 je GS_3
 shr al,1
 jc COP_err
GS_3:
 retn

GS_timer:
 mov eax,es:TimerOffs
 cmp eax,ebx
 jb GS_3
 pop ax
 jmp COP_err
;
;  ॣ ஫ । 樥,   樨  bl.
;
RegPrepare:
  mov dx,port2
  mov al,2
  out dx,al ;  뢠,   믮

  mov dx,port1
  add dx,2
  mov al,tbl_AdrCount
  out dx,al

  mov eax,tbl_AdrStart
  inc dx
  out dx,al ; 7..0 +3

  shr eax,8
  inc dx
  out dx,al ; 15..8 +4

  shr eax,8
  inc dx
  out dx,al ; 23..16 +5

  shr eax,8
  inc dx
  and al,0fh
  or al,sdev
  out dx,al ; 27..24 +6

  mov al,bl
  inc dx
  out dx,al
  retn
